// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: lifecycle_template.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	LifecycleTemplates_GetLifecycleTemplateByID_FullMethodName = "/martiancloud.phobos.api.lifecycletemplate.LifecycleTemplates/GetLifecycleTemplateByID"
	LifecycleTemplates_GetLifecycleTemplates_FullMethodName    = "/martiancloud.phobos.api.lifecycletemplate.LifecycleTemplates/GetLifecycleTemplates"
	LifecycleTemplates_CreateLifecycleTemplate_FullMethodName  = "/martiancloud.phobos.api.lifecycletemplate.LifecycleTemplates/CreateLifecycleTemplate"
	LifecycleTemplates_UploadLifecycleTemplate_FullMethodName  = "/martiancloud.phobos.api.lifecycletemplate.LifecycleTemplates/UploadLifecycleTemplate"
	LifecycleTemplates_GetLifecycleTemplateData_FullMethodName = "/martiancloud.phobos.api.lifecycletemplate.LifecycleTemplates/GetLifecycleTemplateData"
)

// LifecycleTemplatesClient is the client API for LifecycleTemplates service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// LifecycleTemplates implements all functionality related to a Phobos
// LifecycleTemplate.
type LifecycleTemplatesClient interface {
	// GetLifecycleTemplateByID returns a LifecycleTemplate by an ID.
	GetLifecycleTemplateByID(ctx context.Context, in *GetLifecycleTemplateByIdRequest, opts ...grpc.CallOption) (*LifecycleTemplate, error)
	// GetLifecycleTemplates returns a paginated list of LifecycleTemplates.
	GetLifecycleTemplates(ctx context.Context, in *GetLifecycleTemplatesRequest, opts ...grpc.CallOption) (*GetLifecycleTemplatesResponse, error)
	// CreateLifecycleTemplate creates a new LifecycleTemplate.
	CreateLifecycleTemplate(ctx context.Context, in *CreateLifecycleTemplateRequest, opts ...grpc.CallOption) (*LifecycleTemplate, error)
	// UploadLifecycleTemplate uploads to a LifecycleTemplate.
	UploadLifecycleTemplate(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadLifecycleTemplateRequest, emptypb.Empty], error)
	// GetLifecycleTemplateData returns the template data as a stream of chunks
	GetLifecycleTemplateData(ctx context.Context, in *GetLifecycleTemplateDataRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetLifecycleTemplateDataResponse], error)
}

type lifecycleTemplatesClient struct {
	cc grpc.ClientConnInterface
}

func NewLifecycleTemplatesClient(cc grpc.ClientConnInterface) LifecycleTemplatesClient {
	return &lifecycleTemplatesClient{cc}
}

func (c *lifecycleTemplatesClient) GetLifecycleTemplateByID(ctx context.Context, in *GetLifecycleTemplateByIdRequest, opts ...grpc.CallOption) (*LifecycleTemplate, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(LifecycleTemplate)
	err := c.cc.Invoke(ctx, LifecycleTemplates_GetLifecycleTemplateByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lifecycleTemplatesClient) GetLifecycleTemplates(ctx context.Context, in *GetLifecycleTemplatesRequest, opts ...grpc.CallOption) (*GetLifecycleTemplatesResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetLifecycleTemplatesResponse)
	err := c.cc.Invoke(ctx, LifecycleTemplates_GetLifecycleTemplates_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lifecycleTemplatesClient) CreateLifecycleTemplate(ctx context.Context, in *CreateLifecycleTemplateRequest, opts ...grpc.CallOption) (*LifecycleTemplate, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(LifecycleTemplate)
	err := c.cc.Invoke(ctx, LifecycleTemplates_CreateLifecycleTemplate_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lifecycleTemplatesClient) UploadLifecycleTemplate(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadLifecycleTemplateRequest, emptypb.Empty], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &LifecycleTemplates_ServiceDesc.Streams[0], LifecycleTemplates_UploadLifecycleTemplate_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[UploadLifecycleTemplateRequest, emptypb.Empty]{ClientStream: stream}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type LifecycleTemplates_UploadLifecycleTemplateClient = grpc.ClientStreamingClient[UploadLifecycleTemplateRequest, emptypb.Empty]

func (c *lifecycleTemplatesClient) GetLifecycleTemplateData(ctx context.Context, in *GetLifecycleTemplateDataRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetLifecycleTemplateDataResponse], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &LifecycleTemplates_ServiceDesc.Streams[1], LifecycleTemplates_GetLifecycleTemplateData_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[GetLifecycleTemplateDataRequest, GetLifecycleTemplateDataResponse]{ClientStream: stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type LifecycleTemplates_GetLifecycleTemplateDataClient = grpc.ServerStreamingClient[GetLifecycleTemplateDataResponse]

// LifecycleTemplatesServer is the server API for LifecycleTemplates service.
// All implementations must embed UnimplementedLifecycleTemplatesServer
// for forward compatibility.
//
// LifecycleTemplates implements all functionality related to a Phobos
// LifecycleTemplate.
type LifecycleTemplatesServer interface {
	// GetLifecycleTemplateByID returns a LifecycleTemplate by an ID.
	GetLifecycleTemplateByID(context.Context, *GetLifecycleTemplateByIdRequest) (*LifecycleTemplate, error)
	// GetLifecycleTemplates returns a paginated list of LifecycleTemplates.
	GetLifecycleTemplates(context.Context, *GetLifecycleTemplatesRequest) (*GetLifecycleTemplatesResponse, error)
	// CreateLifecycleTemplate creates a new LifecycleTemplate.
	CreateLifecycleTemplate(context.Context, *CreateLifecycleTemplateRequest) (*LifecycleTemplate, error)
	// UploadLifecycleTemplate uploads to a LifecycleTemplate.
	UploadLifecycleTemplate(grpc.ClientStreamingServer[UploadLifecycleTemplateRequest, emptypb.Empty]) error
	// GetLifecycleTemplateData returns the template data as a stream of chunks
	GetLifecycleTemplateData(*GetLifecycleTemplateDataRequest, grpc.ServerStreamingServer[GetLifecycleTemplateDataResponse]) error
	mustEmbedUnimplementedLifecycleTemplatesServer()
}

// UnimplementedLifecycleTemplatesServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedLifecycleTemplatesServer struct{}

func (UnimplementedLifecycleTemplatesServer) GetLifecycleTemplateByID(context.Context, *GetLifecycleTemplateByIdRequest) (*LifecycleTemplate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetLifecycleTemplateByID not implemented")
}
func (UnimplementedLifecycleTemplatesServer) GetLifecycleTemplates(context.Context, *GetLifecycleTemplatesRequest) (*GetLifecycleTemplatesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetLifecycleTemplates not implemented")
}
func (UnimplementedLifecycleTemplatesServer) CreateLifecycleTemplate(context.Context, *CreateLifecycleTemplateRequest) (*LifecycleTemplate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateLifecycleTemplate not implemented")
}
func (UnimplementedLifecycleTemplatesServer) UploadLifecycleTemplate(grpc.ClientStreamingServer[UploadLifecycleTemplateRequest, emptypb.Empty]) error {
	return status.Errorf(codes.Unimplemented, "method UploadLifecycleTemplate not implemented")
}
func (UnimplementedLifecycleTemplatesServer) GetLifecycleTemplateData(*GetLifecycleTemplateDataRequest, grpc.ServerStreamingServer[GetLifecycleTemplateDataResponse]) error {
	return status.Errorf(codes.Unimplemented, "method GetLifecycleTemplateData not implemented")
}
func (UnimplementedLifecycleTemplatesServer) mustEmbedUnimplementedLifecycleTemplatesServer() {}
func (UnimplementedLifecycleTemplatesServer) testEmbeddedByValue()                            {}

// UnsafeLifecycleTemplatesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to LifecycleTemplatesServer will
// result in compilation errors.
type UnsafeLifecycleTemplatesServer interface {
	mustEmbedUnimplementedLifecycleTemplatesServer()
}

func RegisterLifecycleTemplatesServer(s grpc.ServiceRegistrar, srv LifecycleTemplatesServer) {
	// If the following call pancis, it indicates UnimplementedLifecycleTemplatesServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&LifecycleTemplates_ServiceDesc, srv)
}

func _LifecycleTemplates_GetLifecycleTemplateByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetLifecycleTemplateByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LifecycleTemplatesServer).GetLifecycleTemplateByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: LifecycleTemplates_GetLifecycleTemplateByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LifecycleTemplatesServer).GetLifecycleTemplateByID(ctx, req.(*GetLifecycleTemplateByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _LifecycleTemplates_GetLifecycleTemplates_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetLifecycleTemplatesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LifecycleTemplatesServer).GetLifecycleTemplates(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: LifecycleTemplates_GetLifecycleTemplates_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LifecycleTemplatesServer).GetLifecycleTemplates(ctx, req.(*GetLifecycleTemplatesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _LifecycleTemplates_CreateLifecycleTemplate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateLifecycleTemplateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LifecycleTemplatesServer).CreateLifecycleTemplate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: LifecycleTemplates_CreateLifecycleTemplate_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LifecycleTemplatesServer).CreateLifecycleTemplate(ctx, req.(*CreateLifecycleTemplateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _LifecycleTemplates_UploadLifecycleTemplate_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(LifecycleTemplatesServer).UploadLifecycleTemplate(&grpc.GenericServerStream[UploadLifecycleTemplateRequest, emptypb.Empty]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type LifecycleTemplates_UploadLifecycleTemplateServer = grpc.ClientStreamingServer[UploadLifecycleTemplateRequest, emptypb.Empty]

func _LifecycleTemplates_GetLifecycleTemplateData_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(GetLifecycleTemplateDataRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(LifecycleTemplatesServer).GetLifecycleTemplateData(m, &grpc.GenericServerStream[GetLifecycleTemplateDataRequest, GetLifecycleTemplateDataResponse]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type LifecycleTemplates_GetLifecycleTemplateDataServer = grpc.ServerStreamingServer[GetLifecycleTemplateDataResponse]

// LifecycleTemplates_ServiceDesc is the grpc.ServiceDesc for LifecycleTemplates service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var LifecycleTemplates_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.lifecycletemplate.LifecycleTemplates",
	HandlerType: (*LifecycleTemplatesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetLifecycleTemplateByID",
			Handler:    _LifecycleTemplates_GetLifecycleTemplateByID_Handler,
		},
		{
			MethodName: "GetLifecycleTemplates",
			Handler:    _LifecycleTemplates_GetLifecycleTemplates_Handler,
		},
		{
			MethodName: "CreateLifecycleTemplate",
			Handler:    _LifecycleTemplates_CreateLifecycleTemplate_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "UploadLifecycleTemplate",
			Handler:       _LifecycleTemplates_UploadLifecycleTemplate_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "GetLifecycleTemplateData",
			Handler:       _LifecycleTemplates_GetLifecycleTemplateData_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "lifecycle_template.proto",
}
